﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace GrafikLabor {
    class GPanel:Panel {


        String filename;
        Font drawFont1=null;
        SolidBrush drawBrush1;
        SolidBrush drawBrush2 = new SolidBrush(Color.Black);
        Pen penBlack = new Pen(Color.Black, 1);
        Pen penRed = new Pen(Color.Red, 4);
        Brush mybrush1, mybrush2;

        int leftBorder = 0;
        int rightBorder = 100;
        

        public GPanel(Color color, String filename):base()   {            
            // this.SetStyle( ControlStyles.AllPaintingInWmPaint | ControlStyles.UserPaint | ControlStyles.DoubleBuffer, true);            

            base.BackColor = color;
            drawBrush1 = new SolidBrush(color);
            this.filename = filename;
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.panel_Paint);
            this.DoubleBuffered = false;

            drawFont1 = new Font("Courier New", 24);  // Verdana

            initGrafik();
        }

        ~GPanel()         {
            drawFont1.Dispose();
            drawBrush1.Dispose();            
        }

        private void initGrafik() {
            Graphics g = this.CreateGraphics();
            SizeF sf = g.MeasureString("FFFFFF:F", drawFont1); // Leerzeichen gelten nicht
            sf = g.MeasureString("abcdefgh", drawFont1);
            leftBorder = (int)sf.Width;
            rightBorder = (int)(leftBorder + sf.Width);
            penRed.DashStyle = DashStyle.DashDot;
            mybrush1 = new HatchBrush(HatchStyle.ZigZag, Color.Green);
            //Point p1 = new Point(0, 0);
            //Point p2 = new Point(200, 100);	// Größe des Schemas
            //mybrush2 = new LinearGradientBrush(p1, 	 p2,  Color.Red,  Color.Blue  );


        }

        private void panel_Paint(object sender, PaintEventArgs e) {
            //BufferedGraphicsContext bgc = BufferedGraphicsManager.Current;
            //BufferedGraphics canvas = bgc.Allocate(e.Graphics, this.DisplayRectangle);

            //canvas.Graphics.FillRectangle(drawBrush1, new Rectangle(0, 0, Width, Height));

            Graphics g = this.CreateGraphics();
            g.FillRectangle(drawBrush1, new Rectangle(0, 0, Width, Height));
            g.DrawString(Width.ToString(), drawFont1, drawBrush2, 10, 10);
            g.DrawString(Height.ToString(), drawFont1, drawBrush2, 10, 110);
            g.DrawLine(penBlack, 10, 10, Width - 20, Height - 20);
            g.DrawLine(penRed, 10, Height - 20, Width - 20, 10);

            g.FillEllipse(mybrush1, 152, 112, 150, 80);

            Point p1 = new Point(20, Height - 60);
            Point p2 = new Point(Width - 20, Height - 20);
            g.DrawLine(penBlack, p2.X, 100, p2.X, p2.Y);

            mybrush2 = new LinearGradientBrush(p1, p2, Color.Green, Color.Red);
            
            g.FillRectangle(mybrush2, new Rectangle(20, Height - 60, Width - 40, 40));  // x y w h 


            //GraphicsPath path = new GraphicsPath();
            //path.AddRectangle(new Rectangle(20, Height - 60, Width - 40, 40));  // x y w h 

            //// Use the path to construct a brush.
            //PathGradientBrush pthGrBrush = new PathGradientBrush(path);

            //// Set the color at the center of the path to blue.
            //pthGrBrush.CenterColor = Color.FromArgb(255, 0, 0, 255);

            //Color[] colors = { Color.FromArgb(255, 0, 255, 255) };
            //pthGrBrush.SurroundColors = colors;

            //g.FillRectangle(pthGrBrush, new Rectangle(20, Height - 60, Width - 40, 40));  // x y w h 


        }

    }
}
